<template>
  <CForm
    class="search-form"
    @submit.prevent="onSubmit"
  >
    <div class="row">
      <div class="col-12 col-xl-6">
        <CInput
          v-model="name"
          label="Name"
          placeholder="Enter name"
          horizontal
          type="text"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'sitemap']" class="width-1x" />
          </template>
        </CInput>
      </div>

      <div class="col-12 col-xl-6">
        <div role="group" class="form-group form-row">
          <CCol tag="label" sm="3" class="col-form-label">
            Status
          </CCol>
          <CCol sm="9" class="form-inline">
            <app-radio-group v-model="status" :list="[]" :name="'status'" />
          </CCol>
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-12 col-xl-6">
        <CSelect
          v-model="zones"
          label="In zones"
          horizontal
          :options="OPTIONS"
          placeholder="Please select"
          :value.sync="zones"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'th']" class="width-1x" />
          </template>
        </CSelect>
      </div>
    </div>

    <div class="box-form-footer form-group">
      <CButton
        type="submit"
        color="primary"
        :disabled="loading"
      >
        <font-awesome-icon :icon="['fas', 'search']" class="width-1x" />
        Search
      </CButton>
      &nbsp;
      <CButton
        color="secondary"
        :disabled="loading"
        @click="onClearFormSearch"
      >
        <font-awesome-icon :icon="['fas', 'eraser']" class="width-1x" />
        Clear
      </CButton>
    </div>
  </CForm>
</template>

<style lang="scss" scoped>
  /* -----------------------------------------------------------
    search-form
    ----------------------------------------------------------- */
  .search-form {
    /deep/ {
      .col-form-label {
        text-align: right;
        @include mq(max_lg) {
          text-align: left;
        }
      }
      .box-form-footer {
        text-align: center;
        .btn {
          min-width: 100px;
        }
      }
    }
  }
</style>
<script>
import { get, isEqual } from 'lodash'

import AppRadioGroup from '~/components/atoms/AppRadioGroup'

const EVENT_SUBMIT = 'submit'

export default {
  components: {
    AppRadioGroup
  },

  props: {
    /**
     * Default condition
     */
    defaultCondition: {
      type: Object,
      default: () => {}
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      name: '',
      zones: null,
      status: null,
      prevCondition: null,
      data: []
    }
  },

  computed: {
    /**
     * Check disable button search.
     */
    disabled () {
      if (this.prevCondition === null) {
        return false
      }
      return isEqual(this.prevCondition, this.condition)
    },

    /**
     * Get condition input on form
     */
    condition () {
      const condition = {}

      if (this.status !== null) {
        condition.status = this.status
      }

      if (this.name) {
        condition.name = this.name
      }

      if (this.zones) {
        condition.zone_id = this.zones
      }

      return condition
    },

    /**
     * Get zone data options
     *
     */
    OPTIONS () {
      const options = ['Please select']
      this.data.forEach((item) => {
        const param = { value: item.id, label: item.name }
        options.push(param)
      })
      return options
    }
  },

  mounted () {
    this.prepareData()
  },

  methods: {
    /**
     * Clear form data
     *
     */
    onClearFormSearch () {
      this.name = ''
      this.status = null
      this.zones = null
    },

    /**
     * Check validate input
     * If valid then show error
     * Else call submit event of page index
     */
    onSubmit () {
      this.prevCondition = this.condition
      this.$emit(EVENT_SUBMIT, this.condition)
    },

    /**
     * Get value of status
     *
     * @param {Bolean} val - Get is value
     * @param {Object} event - Get event of status
     */
    onChangeStatus (val, event) {
      this.status = parseInt(event.target.value)
    },

    /**
     * Prepare data
     *
     */
    prepareData () {
      this.$dam.getZoneList()
        .then((res) => {
          this.data = res.data
        })
        .catch((err) => {
          const message = get(err, 'response.data.message', null)
          if (message) {
            this.$toast.error(message)
          } else {
            this.$toast.error(
              this.$text.error('FAILED_TO_DATA')
            )
          }
        })
    }
  }
}
</script>
